#include <bits/stdc++.h>
using namespace std;

/// r-u, u-l, l-d, d-r
struct ant
{
    char directory, clossest;
    int place;
};


ant ants[100001];
bool fields[100001];

int calcTurns(const char& from, const char& to)
{
    if(from=='l')
    {
        if(to=='l')
        {
            return 0;
        }
        else if(to=='r')
        {
            return 2;
        }
        else if(to=='d')
        {
            return 1;
        }
        else if(to=='u')
        {
            return 1;
        }
    }
    else if(from=='r')
    {
        if(to=='r')
        {
            return 0;
        }
        else if(to=='l')
        {
            return 2;
        }
        else if(to=='d')
        {
            return 1;
        }
        else if(to=='u')
        {
            return 1;
        }
    }
    else if(from=='d')
    {
        if(to=='d')
        {
            return 0;
        }
        else if(to=='r')
        {
            return 1;
        }
        else if(to=='u')
        {
            return 2;
        }
        else if(to=='l')
        {
            return 1;
        }
    }
    else if(from=='u')
    {
        if(to=='u')
        {
            return 0;
        }
        else if(to=='l')
        {
            return 1;
        }
        else if(to=='d')
        {
            return 2;
        }
        else if(to=='r')
        {
            return 1;
        }
    }
}

int main()
{
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);

    int sizePlaces;
    int numberAnts;

    cin >> sizePlaces;
    cin >> numberAnts;

    for(int currentAnt=0; currentAnt<numberAnts; currentAnt++)
    {
        cin >> ants[currentAnt].place >> ants[currentAnt].directory;

        fields[ants[currentAnt].place]=true;
        int toLeft=ants[currentAnt].place, toRight=(sizePlaces-ants[currentAnt].place+1);
        toLeft+=calcTurns(ants[currentAnt].directory, 'l');
        toRight+=calcTurns(ants[currentAnt].directory, 'r');

        if(toLeft<=toRight)
        {
            ants[currentAnt].clossest='l';
        }
        else
        {
            ants[currentAnt].clossest='r';
        }
    }

    int secondsTurn=0;

    for(int currentAnt=0; currentAnt<numberAnts; currentAnt++)
    {
        secondsTurn=max(secondsTurn, calcTurns(ants[currentAnt].directory, ants[currentAnt].clossest));
    }

    for(int currentAnt=0; currentAnt<numberAnts; currentAnt++)
    {
        int timeToUse=secondsTurn-calcTurns(ants[currentAnt].directory, ants[currentAnt].clossest);
        ants[currentAnt].directory=ants[currentAnt].clossest;

        if(timeToUse==0)
        {
            continue;
        }

        if(ants[currentAnt].clossest=='l')
        {
            for(int currentField=ants[currentAnt].place; currentField>=1 && timeToUse!=0; currentField--)
            {
               if(!fields[currentField])
               {
                   fields[ants[currentAnt].place]=false;
                   ants[currentAnt].place=currentField;
               }
               else
               {
                   break;
               }

               timeToUse--;
            }
        }
        else
        {
            for(int currentField=ants[currentAnt].place; currentField<sizePlaces && timeToUse!=0; currentField++)
            {
               if(!fields[currentField])
               {
                   fields[ants[currentAnt].place]=false;
                   ants[currentAnt].place=currentField;
               }
               else
               {
                   break;
               }

               timeToUse--;
            }
        }
    }

    int maxToFinish=0;

    for(int currentAnt=0; currentAnt<numberAnts; currentAnt++)
    {
        if(ants[currentAnt].clossest=='l')
        {
            maxToFinish=max(maxToFinish, ants[currentAnt].place);
        }
        else
        {
            maxToFinish=max(maxToFinish, numberAnts-ants[currentAnt].place+1);
        }
    }

    cout << secondsTurn+maxToFinish;
    return 0;
}
