/*
#include <iostream>
using namespace std;
int n, k, power[10000000];
bool tournament(int l, int r){
    int fun=0;
    for(int i=l; i<=r; i++) {
        for(int j=i+1; j<=r; j++) {
            fun+=power[i]*power[j];
        }
    }
    return fun>=k;
}
int main(){
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cin>>n>>k;
    for(int i=0; i<n; i++) cin>>power[i];
    int matches=0;
    for(int l=0; l<n-1; l++){
        for(int r=l+1; r<n; r++){
            if(tournament(l, r)) matches++;
        }
    }
    cout<<matches<<"\n";
    return 0;
}

#include <bits/stdc++.h>
using namespace std;
vector<pair<int, char>> pos;
vector<bool> leftBetter;
int n, m;
int main(){
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cin>>n;
    cin>>m;
    for(int i=0; i<m; i++) {
        int pif;
        char pis;
        cin>>pif>>pis;
        pos.push_back({pif, pis});
        leftBetter.push_back(0);
    }
    int rotating=0, moving=0;
    for(int i=0; i<m; i++){
        leftBetter[i]=pos[i].first<(n-pos[i].first+1);
        moving = max(moving, min(pos[i].first, n-pos[i].first));
        if(leftBetter[i]){
            if(pos[i].second=='l') rotating=max(rotating, 0);
            else if(pos[i].second=='r') rotating=max(rotating, 2);
            else rotating=max(rotating, 1);
        }
        else {
            if(pos[i].second=='l') rotating=max(rotating, 2);
            else if(pos[i].second=='r') rotating=max(rotating, 0);
            else rotating=max(rotating, 1);
        }
    }
    cout<<moving+rotating<<"\n";
    return 0;
}
*/
#include <bits/stdc++.h>
using namespace std;
int main(){
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    int n, m, ans=0;
    cin>>n>>m;
    vector<pair<int, int>> tvs(n);
    vector<int> pos(n+1);
    pos[0]=0;
    for(int i=0; i<n; i++) {
        if(i) pos[i]=pos[i-1]+tvs[i-1].first;
        cin>>tvs[i].first>>tvs[i].second;
    }
    pos[n]=tvs[n-1].second+pos[n-1];
    for(int i=0; i<m; i++){
        int x, y, po;
        cin>>x>>y;
        for(int p=0; p<n; p++){
            po=p;
            if(pos[po]<=x && x<=pos[po+1]) break;
        }
        if(tvs[po].second>=y) ans++;
    }
    cout<<ans<<"\n";
    return 0;
}
