#include<iostream>
#include<algorithm>
using namespace std;
int n, m, turn, antsOnLine;
long long ants[100000];
void setAnt(int square, char direction){
    if(direction == 'u'){
        ants[square - 1] = 0;
    }
    if(direction == 'r'){
        ants[square - 1] = 1;
    }
    if(direction == 'd'){
        ants[square - 1] = 0;
    }
    if(direction == 'l'){
        ants[square - 1] = -1;
    }
}
bool facingCorrectDir(int ant){
    if(ants[ant] == 0){
        return false;
    }
    if(ants[ant] == 1){
        if(ant >= n / 2){
            return true;
        }
        return false;
    }
    if(ant <= n / 2){
        return true;
    }
    return false;
}
void turnAnt(int ant){
    if(ants[ant] == 0){
        if(ant >= n / 2){
            ants[ant] = 1;
        }else{
            ants[ant] = -1;
        }
    }else{
        ants[ant] = 0;
    }
}
bool willSpaceBeFree(int i){
    if(i < 0 || i >= n) return true;
    if(ants[i] == 2) return true;
    if(ants[i] == -1) return willSpaceBeFree(i - 1);
    if(ants[i] == 1) return willSpaceBeFree(i + 1);
}
void moveAnt(int ant){
    if(ants[ant + ants[ant]] == 2){
        ants[ant + ants[ant]] = ants[ant];
        ants[ant] = 2;
    }else if(ant + ants[ant] < 0 || ant + ants[ant] >= n){
        ants[ant] = 2;
        antsOnLine--;
    }
}
int main(){
    cin >> n >> m;
    antsOnLine = 0;
    for(int i = 0; i < n; ++i){
        ants[i] = 2;
    }
    for(int i = 0; i < m; ++i){
        char direction;
        int antPos;
        cin >> antPos >> direction;
        setAnt(antPos, direction);
        antsOnLine++;
    }
  /*  for(int i = 0; i < n; ++i){
        cout << ants[i] << " ";
    }
    cout << endl;*/
    for(turn = 0; antsOnLine > 0; ++turn){
        for(int i = 0; i < n; ++i){
            if(ants[i] < 2){
                if(!facingCorrectDir(i)){
                    turnAnt(i);
                }else if(willSpaceBeFree(i + ants[i])){
                    moveAnt(i);
                }
            }
        }
        /*for(int i = 0; i < n; ++i){
            cout << ants[i] << " ";
        }
        cout << endl;*/
    }
    cout << turn;
    return 0;
}
