#include <bits/stdc++.h>
using namespace std;

/// r-u, u-l, l-d, d-r
struct ant
{
    char directory, clossest;
    int place;
};


ant ants[100001];
bool fields[100001];

int calcTurns(const char& from, const char& to)
{
    if(from=='l')
    {
        if(to=='l')
        {
            return 0;
        }
        else if(to=='r')
        {
            return 2;
        }
        else if(to=='d')
        {
            return 1;
        }
        else if(to=='u')
        {
            return 1;
        }
    }
    else if(from=='r')
    {
        if(to=='r')
        {
            return 0;
        }
        else if(to=='l')
        {
            return 2;
        }
        else if(to=='d')
        {
            return 1;
        }
        else if(to=='u')
        {
            return 1;
        }
    }
    else if(from=='d')
    {
        if(to=='d')
        {
            return 0;
        }
        else if(to=='r')
        {
            return 1;
        }
        else if(to=='u')
        {
            return 2;
        }
        else if(to=='l')
        {
            return 1;
        }
    }
    else if(from=='u')
    {
        if(to=='u')
        {
            return 0;
        }
        else if(to=='l')
        {
            return 1;
        }
        else if(to=='d')
        {
            return 2;
        }
        else if(to=='r')
        {
            return 1;
        }
    }
}

int main()
{
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);

    int sizePlaces;
    int numberAnts;

    cin >> sizePlaces;
    cin >> numberAnts;

    for(int currentAnt=0; currentAnt<numberAnts; currentAnt++)
    {
        cin >> ants[currentAnt].place >> ants[currentAnt].directory;

        fields[ants[currentAnt].place]=true;
        int toLeft=ants[currentAnt].place, toRight=(sizePlaces-ants[currentAnt].place+1);
        toLeft+=calcTurns(ants[currentAnt].directory, 'l');
        toRight+=calcTurns(ants[currentAnt].directory, 'r');

        if(toLeft<=toRight)
        {
            ants[currentAnt].clossest='l';
        }
        else
        {
            ants[currentAnt].clossest='r';
        }
    }

    int secondsTurn=0;

    for(int currentAnt=0; currentAnt<numberAnts; currentAnt++)
    {
        secondsTurn=max(secondsTurn, calcTurns(ants[currentAnt].directory, ants[currentAnt].clossest));
    }

    int currentAntL=0;

    for(currentAntL; currentAntL<numberAnts; currentAntL++)
    {
        if(ants[currentAntL].clossest=='r')
        {
            break;
        }

        int timeToUse=secondsTurn-calcTurns(ants[currentAntL].directory, ants[currentAntL].clossest);
        ants[currentAntL].directory=ants[currentAntL].clossest;

        if(timeToUse==0)
        {
            continue;
        }

        for(int currentField=ants[currentAntL].place; currentField>=1 && timeToUse!=0; currentField--)
        {
            if(ants[currentAntL].place==1)
            {
                fields[ants[currentAntL].place]=false;
                ants[currentAntL].place=0;
            }

            if(!fields[currentField])
            {
                fields[ants[currentAntL].place]=false;
                ants[currentAntL].place=currentField;
            }
            else
            {
                break;
            }

            timeToUse--;
        }
    }

    int currentAntR=numberAnts-1;
    int wasIn;

    if(currentAntL!=numberAnts-1)
    {
        wasIn=0;
    }
    else
    {
        wasIn=1;
    }


    for(currentAntR; currentAntR>=currentAntL+wasIn; currentAntR--)
    {
        int timeToUse=secondsTurn-calcTurns(ants[currentAntR].directory, ants[currentAntR].clossest);
        ants[currentAntR].directory=ants[currentAntR].clossest;

        if(timeToUse==0)
        {
            continue;
        }

        for(int currentField=ants[currentAntR].place; currentField<sizePlaces && timeToUse!=0; currentField++)
        {
            if(ants[currentAntR].place==sizePlaces-1)
            {
                fields[ants[currentAntR].place]=false;
                ants[currentAntR].place=sizePlaces;
                break;
            }

            if(!fields[currentField])
            {
                fields[ants[currentAntR].place]=false;
                ants[currentAntR].place=currentField;
            }
            else
            {
                break;
            }

            timeToUse--;
        }
    }


    int maxToFinish=0;

    for(int currentAnt=0; currentAnt<numberAnts; currentAnt++)
    {
        if(ants[currentAnt].clossest=='l')
        {
            maxToFinish=max(maxToFinish, ants[currentAnt].place);
        }
        else
        {
            maxToFinish=max(maxToFinish, sizePlaces-ants[currentAnt].place+1);
        }
    }

    cout << secondsTurn+maxToFinish+1;
    return 0;
}
