/*
#include <iostream>
using namespace std;
int n, k, power[10000000];
bool tournament(int l, int r){
    int fun=0;
    for(int i=l; i<=r; i++) {
        for(int j=i+1; j<=r; j++) {
            fun+=power[i]*power[j];
        }
    }
    return fun>=k;
}
int main(){
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cin>>n>>k;
    for(int i=0; i<n; i++) cin>>power[i];
    int matches=0;
    for(int l=0; l<n-1; l++){
        for(int r=l+1; r<n; r++){
            if(tournament(l, r)) matches++;
        }
    }
    cout<<matches<<"\n";
    return 0;
}
*/
#include <bits/stdc++.h>
using namespace std;
vector<pair<int, char>> pos;
vector<bool> leftBetter;
int n, m;
int main(){
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cin>>n;
    cin>>m;
    for(int i=0; i<m; i++) {
        int pif;
        char pis;
        cin>>pif>>pis;
        pos.push_back({pif, pis});
        leftBetter.push_back(0);
    }
    int reversing=0, walking=0;
    for(int i=0; i<m; i++){
        leftBetter[i]=pos[i].first<(n-pos[i].first+1);
        walking = max(walking, min(pos[i].first, n-pos[i].first));
        if(leftBetter[i]){
            if(pos[i].second=='l') reversing=max(reversing, 0);
            else if(pos[i].second=='r') reversing=max(reversing, 2);
            else reversing=max(reversing, 1);
        }
        else {
            if(pos[i].second=='l') reversing=max(reversing, 2);
            else if(pos[i].second=='r') reversing=max(reversing, 0);
            else reversing=max(reversing, 1);
        }
    }
    cout<<walking+reversing<<"\n";
    return 0;
}
